#-*- coding: utf-8 -*-
from Components.config import config, configfile
from enigma import eTimer
from Tools.Directories import fileExists, resolveFilename, SCOPE_PLUGINS
from twisted.web.client import downloadPage, getPage, error
from twisted.internet import defer
import urllib, re, datetime, time
import os
import sys

# our custom classes
from SkyRunAutocheck import SkyRunAutocheck
from SkyMainFunctions import nonHDeventList, buildSkyChannellist, decodeHtml, getHttpHeader, getUserAgent, getHttpHeader2, getEventAllowedRange, getDayOfTheWeek, getDateFromTimestamp, getCurrentTimestamp
from SkySql import *

class SkyGetTvGuide():


	def __init__(self, session, oneShot = False):

		# singleton class - needed to call it at sessionstart
		SkyGetTvGuide.instance = self

		self.session = session
		self.oneShot = oneShot

		self.nonHDeventList = nonHDeventList()
		self.sky_chlist = buildSkyChannellist()
		self.headers = getHttpHeader()
		self.agent = getUserAgent()
		self.headers2 = getHttpHeader2()
		
		self.pluginName = config.plugins.skyanytime.pluginname.value
		
		self.ck = {}
		self.sky_log_path = "/usr/lib/enigma2/python/Plugins/Extensions/skyanytime/sky_log"

		if self.oneShot or str(config.plugins.skyanytime.refreshtimer_interval.value) != "no":
			print "[skyanytime] timer AutotimerCheck gesetzt"
			
			# FIXME
			# be sure, we got a new timestamp, even something goes wrong
			config.plugins.skyanytime.lastchecked.value = getCurrentTimestamp()
			config.plugins.skyanytime.lastchecked.save()
			configfile.save()
			
			# let us start it right now. needed fot wakMeUp function
			# later we can add some config option to only do this if we are sleeping
			# but for now, we fire it up one time
			if self.oneShot:
				#self.start
				self.tempTimer = None
				self.tempTimer = eTimer()
				self.tempTimer.callback.append(self.start(self.oneShot))
				self.tempTimer.start(5000, True) # give us some time to breath, before we start
			
			if str(config.plugins.skyanytime.refreshtimer_interval.value) != "no":
				self.refreshTimer = eTimer()
				self.refreshTimer.callback.append(self.start)
				self.timerinterval = int(config.plugins.skyanytime.refreshtimer_interval.value) * 60000
				self.refreshTimer.start(self.timerinterval)

	def start(self,oneShot=False):
		if oneShot or str(config.plugins.skyanytime.refreshtimer_interval.value) != "no":
			msg_log = "[skyanytime] aktualisiere Datenbank..."
			print msg_log
			self.addLog(msg_log)

			try:
				sql.cur.execute('SELECT SQLITE_VERSION()')
			except Exception:
				sys.exc_clear()
				try:
					sql.connect()
				except Exception:
					return
					
			# first clean up old files
			msg_log = "[skyanytime] entferne alte Eintraege..."
			print msg_log
			self.addLog(msg_log)
			n = sql.deleteEvents(getCurrentTimestamp())
			msg_log = "[skyanytime] {0} Eintraege geloescht".format(n)
			print msg_log
			self.addLog(msg_log)
			
			try:
				try:
					sql.cur.execute('SELECT SQLITE_VERSION()')
				except Exception:
					sys.exc_clear()
					try:
						sql.connect()
					except Exception:
						return
				self.getPreCookie()
			except Exception, e:
				sys.exc_clear()
				msg_log="first check failed with: %s \ttrying second check" % e
				self.checkDone(msg_log, False)
				try:
					try:
						sql.cur.execute('SELECT SQLITE_VERSION()')
					except Exception:
						sys.exc_clear()
						try:
							sql.connect()
						except Exception:
							return
					self.getCookie()
				except Exception, e:
					sys.exc_clear()
					msg_log="failed with: %s \ttrying second check" % e
					self.checkDone(msg_log, True)
			
			
	def getPreCookie(self, data=None):
		# Sky changed its main TV-Guide URL - looks crazy :)
		# is Sky watching us ;)
		url = "http://www.sky.de/web/cms/de/tv-guide-erst-aus-strahlung.jsp?alllnk=tvguide:erstausstrahlungen"
		#url = "http://www.sky.de/web/cms/de/tvguide-erstausstrahlungen.jsp?alllnk=tvguide:erstausstrahlungen"
		getPage(url, agent=self.agent, timeout=60, cookies=self.ck, headers=self.headers).addCallback(self.getCookie).addErrback(self.dataError)
				
	def getCookie(self, data=None):		
		self.postargs = urllib.urlencode({"selectedPeriodId": 1, "forward_currentPage": "/cms/de/tv-guide-erst-aus-strahlung.jsp"})
		url = "http://www.sky.de/web/common/tvkalender/boundary/timePeriodRH.do"
		getPage(url, method='POST', postdata=self.postargs, headers=self.headers, agent=self.agent, timeout=60, cookies=self.ck, followRedirect=1).addCallback(self.readGuide).addErrback(self.dataError)


	def readGuide(self, data=None):
		# determine the max pagenumber
		maxpage = 1
		if data:
			pagenumbers = re.findall('<a href=".*?class="sendetitel">(.*?)</a>', data, re.S|re.I)
			if pagenumbers:
				maxpage = int(max(pagenumbers))

		# FIXME
		self.pages = None
		self.pages = ""
		self.pagedone = None
		self.pagedone = []
		self.pagetodo = None
		self.pagetodo = []

		self.getSkyGuidePages(maxpage)

	# FIXME: workaround method to get pagerange
	def getCurrentPageRange(self, data):
		resultrange = re.findall('<div class="BlaetternStatus">.*?(.*?)von(.*?)gefundenen Sendungen.*?</div>', data, re.S|re.I)
		currentrange = []
		if resultrange:
			for currentset,setcount in resultrange:
				currentset = currentset.strip()
				setcount = setcount.strip()
				if currentset in currentrange:
					continue
				currentrange.append(currentset)
		return [currentrange[0],setcount]


	def getSkyGuidePages(self,maxpage):
		urls = []
		for cur_pagenr in range(1,maxpage +1):
			urls.append((cur_pagenr, maxpage, "http://www.sky.de/web/common/epg/boundary/scrollSearchResultRH.do?forward_currentPage=/cms/de/tv-guide-erst-aus-strahlung.jsp&searchString=null&tvg=true&page=%s" % str(cur_pagenr)))

		if len(urls) != 0:
			ds = defer.DeferredSemaphore(tokens=1)
			downloads = [ds.run(self.guideDataDownload,url).addCallback(self.joinSkyGuidePages, cur_pagenr, maxpage, url).addErrback(self.dataError) for (cur_pagenr, maxpage,url) in urls]
			finished = defer.DeferredList(downloads).addErrback(self.dataError)


	def regetSkyGuidePages(self,todourls):
		urls = []
		self.pagetodo = None
		self.pagetodo = []
		maxpage = len(todourls)
		for cur_pagenr in range(0,maxpage):
			urls.append((cur_pagenr + 1, maxpage, todourls[cur_pagenr]))
		
		if len(urls) != 0:
			ds = defer.DeferredSemaphore(tokens=1)
			downloads = [ds.run(self.guideDataDownload,url).addCallback(self.joinSkyGuidePages, cur_pagenr, maxpage, url).addErrback(self.dataError) for (cur_pagenr, maxpage,url) in urls]
			finished = defer.DeferredList(downloads).addErrback(self.dataError)


	def guideDataDownload(self, url):
		return getPage(url, agent=self.agent, timeout=60, cookies=self.ck, headers=self.headers)


	def joinSkyGuidePages(self, data, cur_pagenr, maxpage, url):
		try:
			pagerange = self.getCurrentPageRange(data)
			self.pagedone.append(pagerange[0])
			if self.pagedone.count(pagerange[0]) > 1:
				self.pagetodo.append(url)
			else:
				self.pages += data
		except Exception, e:
			self.pagetodo.append(url)

		if cur_pagenr == maxpage:
			data = None
			if len(self.pagetodo) > 0:
				debugValue = ""
				for aLine in self.pagetodo:
					debugValue += str(aLine) + "\n"
				#self.writeSkyGuideData(debugValue)
				self.regetSkyGuidePages(self.pagetodo)
				#self.guideData(self.pages)
			else:
				self.guideData(self.pages)	


	def guideData(self, data):
		print "Daten erhalten"
		msg_log = "[skyanytime] hole sendetermine..."
		print msg_log
		self.addLog(msg_log)

		termine = re.findall('<div class="contentTVGuideImg">.*?<img src="(.*?)".*?ausstrahlungsID.(.*?)".*?>(.*?)<.*?<p>(.*?)</p>.*?<p>.*?\n.*?\n(.*?)\n.*?<strong>(.*?)</strong>', data, re.S|re.I)
		if termine:
			urls = []
			eventnumber = None
			eventnumber = 0
			for image,sky_id,title,description,genre,sender in termine:
				stopit = False

				if re.match('.*[a-z]', title, re.I):
					title = title.strip()
					title = decodeHtml(title)
				else:
					# no title, skip here
					continue

				image = "http://www.sky.de%s" % image

				if re.match('.*[a-z]', genre, re.I):
					genre = genre.strip('  ')
					genre = decodeHtml(genre)
				else:
					genre = "-"
					
				description = filter(lambda x: not re.match(r'^$', x), description)
				if re.match('.*[a-z]', description, re.I):
					description = description.strip()
					description = decodeHtml(description)
				else:
					description = genre

				try:
					sql.cur.execute('SELECT SQLITE_VERSION()')
				except Exception:
					sys.exc_clear()
					try:
						sql.connect()
					except Exception:
						return

				id_channel = sql.getIdChannel(sender,stb=False)
				if id_channel is False:
					continue

				try:
					sql.cur.execute('SELECT SQLITE_VERSION()')
				except Exception:
					sys.exc_clear()
					try:
						sql.connect()
					except Exception:
						return

				id_genre = sql.getIdGenre(genre)
				if id_genre is False:
					continue

				eventnumber += 1

				if (re.match('.*?HD', sender, re.I) and sender not in self.nonHDeventList):
					#print "HD"
					urls.append((title,description,sky_id,id_channel,id_genre,image,eventnumber, "http://www.sky.de/web/cms/de/modules/pip/de.premiere.modules.tvguide.pip.standard.jsp?ausstrahlungsID="+sky_id+"&eventNr=null&page=sendeterminehdtv&highlightUrl=&menuepath="))
				else:
					#print "SD"
					urls.append((title,description,sky_id,id_channel,id_genre,image,eventnumber, "http://www.sky.de/web/cms/de/modules/pip/de.premiere.modules.tvguide.pip.standard.jsp?ausstrahlungsID="+sky_id+"&eventNr=null&page=sendetermine&highlightUrl=&menuepath="))

			maxevents = len(urls)
			if maxevents != 0:
				finished = None
				ds = None
				ds = defer.DeferredSemaphore(tokens=1)
				downloads = [ds.run(self.download,url).addCallback(self.dataTermine, title, description, sky_id,id_channel,id_genre, image, eventnumber, maxevents).addErrback(self.dataError) for (title, description, sky_id,id_channel,id_genre,image,eventnumber, url) in urls]
				finished = defer.DeferredList(downloads).addErrback(self.dataError)


	def download(self, url):
		return getPage(url, agent=self.agent, timeout=60, cookies=self.ck, headers=self.headers)


	def dataError(self, error):
		print error
		self.checkDone(error, False)
		
		
	def dataTermine(self, data, title, description, sky_id,id_channel,id_genre, image,eventnumber, maxevents):
		sendeTermine = re.findall('<tr.*?<td>(.*?)</td>.*?<td>(.*?).-.(.*?).Uhr.*?<td>(.*?)</td>', data, re.S)
		if sendeTermine:
			canskip = False

			msg = "[skyanytime] hole sendetermine %s von %s (current sky_id: %s)" % (eventnumber, maxevents, sky_id)
			print msg
			self.addLog(msg)

			status = "False" # defaults to False, to indicate its unadded in recordtimer
			id_events = None
			try:
				sql.cur.execute('SELECT SQLITE_VERSION()')
			except Exception:
				sys.exc_clear()
				try:
					sql.connect()
				except Exception:
					return

			id_events = sql.addEvent(title, description, sky_id,image, id_channel, id_genre)
			if not id_events:
				print "Fehler: addEvent"
				self.addLog("Fehler: addEvent")
			else:
				msg = "added or ignored event with id_events %s" % str(id_events)
				print msg
				#self.addLog(msg)


			for (datum,starttime,endtime,channel) in sendeTermine:
				# if the starttime is in the past, continue to then next event
				tstamp_start = self.unixtime(datum, starttime)
				tstamp_end = self.unixtime(datum, endtime)
				skytime = self.skyTimeStamp(starttime, tstamp_start, tstamp_end)
				if getCurrentTimestamp() > skytime[0]:
					continue

				datum = None
				datum = getDateFromTimestamp(skytime[0])

				dayname = None
				dayname = getDayOfTheWeek(skytime[0], False)

				id_eventslist = None
				try:
					sql.cur.execute('SELECT SQLITE_VERSION()')
				except Exception:
					sys.exc_clear()
					try:
						sql.connect()
					except Exception:
						return
				id_eventslist = sql.addEventList(dayname, datum, skytime[0], skytime[1], status, id_events)
				if not id_eventslist:
					print "Fehler: addEventList"
					self.addLog("Fehler: addEventList")
				else:
					msg = "added or ignored eventlist entry with id_eventslist %s" % str(id_eventslist)
					print msg
					#self.addLog(msg)

		if int(eventnumber) >= int(maxevents):
			# clenup objects
			self.pages = None
			self.checkDone("Datenbank aktualisiert", set_stamp = True)



	def checkDone(self, msg_log="", set_stamp = True):
		# we are done
		# store our latest update timestamp for the wakeMeUp function
		if set_stamp:
			config.plugins.skyanytime.lastchecked.value = getCurrentTimestamp()
			config.plugins.skyanytime.lastchecked.save()
			configfile.save()
		print msg_log
		self.addLog(msg_log)

		# if we want automatic recordtimerentries, we start here
		if config.plugins.skyanytime.auto_recordtimer_entries.value:
			SkyRunAutocheck(self.session)	


	def unixtime(self, datum, uhrzeit):
		(std,min) = uhrzeit.split(':')
		(day,month,year) = datum.split('.')
		year = "20%s" % year
		print year, month, day, std, min
		time_date = datetime.datetime(int(year), int(month), int(day), int(std), int(min))
		return int(time.mktime(time_date.timetuple()))


	# fix sky-guide-time, cause skydays starting at 06:00
	def skyTimeStamp(self, uhrzeit, startstamp, endstamp):
		(std,min) = uhrzeit.split(':')
		# fix endtime is in the past
		if endstamp < startstamp:
			endstamp += (3600 * 24)
		# get duration	
		stampdiff = endstamp - startstamp
		# build real start and end timestamps
		if int(std) < 6 and int(std) >= 0:
			startstamp += (3600 * 24)
			endstamp = startstamp + stampdiff
		return [startstamp, endstamp]


	def addLog(self, text):
		if len(text) < 1:
			return
		# check the current file size truncate the file if size is greater than defined limit 100 KB (102400 Bytes)
		sizeb = os.path.getsize(self.sky_log_path)
		if sizeb > 102400:
			# truncate only the first 100 lines in file - delete the oldest ones
			with open(self.sky_log_path, "r+") as f:
				for x in xrange(100):
					f.readline()
					f.truncate()

		lt = time.localtime()
		datum = time.strftime("%d.%m.%Y - %H:%M:%S", lt)
		with open(self.sky_log_path , "a") as write_log:
			write_log.write('"%s - %s"\n' % (datum,text))


